<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="main.css" />
</head>
<body>
    <div class="url-container">
        <h2>URL Del Back-End:</h2>
        <input id="url" placeholder="Backend URL" type="text" value="http://localhost:3000">
    </div>
    

    <form id="create-post-form">
        <h1>Crear Publicación</h1>

        <label>
            <h2>Titulo</h2>
            <input id="title" type="text" placeholder="Titulo De La Publicación" required>
        </label>

        <label>
            <h2>Contenido</h2>
            <input id="content" type="text" placeholder="Contenido De La Publicación" required>
        </label>

        <input type="submit" value="Crear Publicación">
    </form>

    <div id="posts-container">

    </div>

    <script src="https://cdn.jsdelivr.net/npm/axios@1.1.2/dist/axios.min.js"></script>
    <script type="text/javascript">
        const inputField = document.getElementById('url');
        const postForm = document.getElementById('create-post-form');
        const titleField = document.getElementById('title');
        const contentField = document.getElementById('content');
        const postsContainer = document.getElementById('posts-container');

        let posts = [];

        async function SetPosts(newPosts) {
            posts = newPosts;

            await RenderPosts();
        }

        async function RenderPosts() {
            postsContainer.innerHTML = '';

            posts.forEach(element => {
                const div = document.createElement('div');
                div.classList.add('post');
                div.innerHTML = `
                <h1>${element.title}</h1>

                <p>
                    ${element.content}
                </p>

                <div class="button-container">
                    <button class="delete-button">Eliminar</button>

                    <button class="update-button">Actualizar</button>
                </div>
                `;

                div.getElementsByClassName('delete-button')[0].addEventListener('click', async () => {
                    await axios.delete(`${inputField.value}/posts/${element.id}`);

                    SetPosts(await GetPosts());
                });

                div.getElementsByClassName('update-button')[0].addEventListener('click', async () => {
                    console.log(element.content);

                    div.innerHTML = `
                    <label class="new-field-label">
                        <h2>Nuevo Titulo:</h2>
                        <input class="new-title-field" type=text value="${element.title}" placeholder="Titulo" required>
                    </label>

                    <label class="new-field-label">
                        <h2>Nuevo Contenido:</h2>
                        <input class="new-content-field" type=text value="${element.content}"" placeholder="Contenido" required>
                    </label>

                    <div class="button-container">
                        <button class="confirm-button">Confirmar</button>
                    </div>
                    `;

                    div.getElementsByClassName('confirm-button')[0].addEventListener('click', async () => {
                        const newTitleField = div.getElementsByClassName('new-title-field')[0];
                        const newContentField = div.getElementsByClassName('new-content-field')[0];

                        await axios.put(`${inputField.value}/posts/${element.id}`, {
                            title: newTitleField.value,
                            content: newContentField.value
                        });

                        SetPosts(await GetPosts());
                    });
                });

                postsContainer.appendChild(div);
            });
        }

        async function UpdatePost() {
            const res = await axios.put
        }

        async function GetPosts() {
            const res = await axios.get(`${inputField.value}/posts`);

            return res.data;
        }

        async function CreatePost(title, content) {
            
            const res = await axios.post(`${inputField.value}/posts`, {
                title,
                content
            });

            SetPosts(await GetPosts());
        }

        function handleSumbit(e) {
            e.preventDefault();

            const title = titleField.value;
            const content = contentField.value;

            CreatePost(title, content);
        }

        postForm.addEventListener('submit', handleSumbit);
        
        (async () => {
            SetPosts(await GetPosts());
        })();
    </script>
</body>
</html>